SystemOrganization addCategory: #Metaprogramacion!

!ClassDescription methodsFor: '*Metaprogramacion' stamp: 'SebastianGarbi 6/19/2013 20:35'!
lookForMisingImplementors: aMessage
	self methodDict at: aMessage  ifAbsent: [ Error signal: 'No existe el Mensaje'  ] .
	Error signal: 'El Metodo no es abstracto'.
	! !

Object subclass: #ClasePruebaConMetodoAbstracto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClasePruebaConMetodoAbstracto methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/19/2013 20:59'!
metodoAbstracto
	self subclassResponsibility.! !

Object subclass: #ClasePruebaSinMetodosPropios
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

TestCase subclass: #MetaprogamacionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/19/2013 21:02'!
test01LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageDoesNotExists
	
	self should: [ClasePruebaSinMetodosPropios lookForMisingImplementors: #mensajeQueNoExiste]  raise: Error withExceptionDo: [ :anError |  self assert: anError messageText = 'No existe el Mensaje'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/19/2013 21:02'!
test02LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageDoesNotExists
	
	self should: [ClasePruebaSinMetodosPropios class lookForMisingImplementors: #mensajeQueNoExiste]  raise: Error withExceptionDo: [ :anError |  self assert: anError messageText = 'No existe el Mensaje'].
	 ! !

!MetaprogamacionTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/19/2013 21:02'!
test03LookForMissingImplementorsShouldRaiseAnExceptionWhenMessageIsNotAbstract
	
	self should: [ClasePruebaSinMetodosAbstractos  lookForMisingImplementors: #mensajeQueExisteYNoEsAbstracto]  raise: Error withExceptionDo: [ :anError |  self assert: anError messageText = 'El Metodo no es abstracto'].
	 ! !
